org.eclipse.microprofile.reactive.messaging

## Enum Acknowledgment.Strategy

- java.lang.Object
- - java.lang.Enum<Acknowledgment.Strategy>
  - - org.eclipse.microprofile.reactive.messaging.Acknowledgment.Strategy

All Implemented Interfaces:
  Serializable, Comparable<Acknowledgment.Strategy>

Enclosing class:
  Acknowledgment

    public static enum Acknowledgment.Strategy
    extends Enum<Acknowledgment.Strategy>

### Enum Constant Summary

Enum Constants
Enum Constant and Description
`MANUAL` Acknowledgment managed by the user code.
`NONE` No acknowledgment is performed, neither implicitly or explicitly.
`POST_PROCESSING` Acknowledgment performed automatically once the message has been processed.
`PRE_PROCESSING` Acknowledgment performed automatically before the processing of the message by the user code.

### Method Summary

All Methods Static Methods Concrete Methods
`static Acknowledgment.Strategy` `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static Acknowledgment.Strategy[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### MANUAL

    public static final Acknowledgment.Strategy MANUAL

Acknowledgment managed by the user code. No automatic acknowledgment is performed. This strategy is only supported by methods consuming `Message` instances.

#### PRE_PROCESSING

    public static final Acknowledgment.Strategy PRE_PROCESSING

Acknowledgment performed automatically before the processing of the message by the user code.

#### POST_PROCESSING

    public static final Acknowledgment.Strategy POST_PROCESSING

Acknowledgment performed automatically once the message has been processed. When `POST_PROCESSING` is used, the incoming message is acknowledged when the produced message is acknowledged. Notice that this mode is not supported for all signatures. When supported, it's the default policy.

#### NONE

    public static final Acknowledgment.Strategy NONE

No acknowledgment is performed, neither implicitly or explicitly. It means that the incoming messages are going to be acknowledged in a different location or using a different mechanism.

### Method Detail

#### values

    public static Acknowledgment.Strategy[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (Acknowledgment.Strategy c : Acknowledgment.Strategy.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static Acknowledgment.Strategy valueOf(String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null